## pinball-table-hurd 0.0.20230219

=== snap/image/Makefile ===
#!/usr/bin/make -f
# -*- makefile -*-
# ex: set tabstop=4 noexpandtab:
# SPDX-License-Identifier: GPL-2+
# Copyright: Philippe Coval <https://purl.org/rzr/>

default: archive

project?= pinball-table-hurd

-include ~/bin/mk-private.mk

gadget?=pc
base?=core
base_version?=20
architecture?=amd64
channel?=${base_version}/edge

export architecture
name?=${project}-${base}${base_version}-${architecture}-${gadget}
developer_id?=$(shell snapcraft whoami \
	| grep 'developer-id:' | cut -d' ' -f2 \
	|| echo "TODO: https://ubuntu.com/core/docs/custom-images")
authority_id?=${developer_id}
brand_id?=${authority_id}
ubuntu_image_snap_options?=
# image_size?=3G
# ubuntu_image_snap_options+=--image-size ${image_size}
key?=${project}

all?=version
all+=pc
all+=pi

sudo?=sudo


help:
	snap keys

all: ${all}
	-sync

setup/snap:
	snap list
	${sudo} snap install snapcraft --edge
	${sudo} snap install ubuntu-image --edge
	${sudo} snap refresh
	snap list
	snap info ${project}

snap/snapcraft.yaml:
	${@D} init

archive: ${name}.img.gz
	du -hs $<

${name}.json: ubuntu-image-${gadget}.json Makefile
	jq -M . $<
	sed -e "s|{architecture}|${architecture}|g" < $< \
	| jq -r '.["authority-id"] = "${authority_id}"' \
	| jq -r '.architecture = "${architecture}"' \
	| jq -r '.["brand-id"] = "${brand_id}"' \
	| sponge $@
	jq -M . $@

image: ${name}.img.gz
	du -hs $<

%.img: %.model
	-mv $@.manifest $@.manifest.prev.tmp
	ubuntu-image snap ${ubuntu_image_snap_options} -o $@ $<
	sort seed.manifest | tee $@.manifest
	rm seed.manifest
	-diff -u $@.manifest.prev.tmp $@.manifest
	du -hsc $@

%.model: %.json timestamp Makefile
	jq -M . $< | snap sign -k ${key} > $@.tmp
	mv $@.tmp $@

timestamp: ${name}.json
	jq -M . "$<" | sed \
-e "s|\"timestamp\": .*|\"timestamp\": \"$$(date -Iseconds --utc)\",|g" \
	| jq -M . > "$<.tmp"
	mv "$<.tmp" "$<"

clean:
	rm -fv *~ *.img *.img.gz *.model

%.img.gz: %.img
	rm -f "$@"
	du -hsc $<
	gzip -9 $<
	du -hsc $@

pc:
	${MAKE} gadget=$@ architecture=amd64

pi:
	${MAKE} gadget=$@ architecture=arm64

pi3:
	${MAKE} gadget=pi architecture=armhf

version:
	${MAKE} --version
	ubuntu-image --version
	snapcraft version
	snap --version
	jq --version

%.key.tmp:
	snap keys | grep "^${key}" \
	|| snap create-key ${key}
	snap keys | grep "^${key}" | awk '{ print $$2 }' | tee $@


register:
	snapcraft list | grep '^${project} ' && exit 1
	snapcraft whoami || snapcraft login
	snapcraft whoami | grep '^developer-id: ${developer_id}'
	snapcraft list | grep '^${project} ' || snapcraft register "${project}"
	snapcraft list | grep '^${project} '

${project}.reg.tmp:
	snapcraft list | grep '^${project} ' || ${MAKE} register
	snapcraft list | grep '^${project} ' | tee "$@"

key: ${project}.key.tmp
	ls $<

run/%: %.img
	sudo qemu-system-x86_64 \
	-enable-kvm -smp 2 -m 1500 -cpu host \
	-device virtio-vga,virgl=on \
	-drive file=/usr/share/OVMF/OVMF_CODE.fd,if=pflash,format=raw,unit=0,readonly=on \
	-device virtio-net-pci,netdev=net0 \
	-netdev user,id=net0,hostfwd=tcp::50022-:22,hostfwd=tcp::50080-:80 \
	-drive file=$<,format=raw

run: run/${name}


.PRECIOUS: \
	%.img \
	%.model \
#EOL

## pinball-table-hurd 0%2B0.0.20230219

=== debian/changelog ===
pinball-table-hurd (0+0.0.20230219-0.0.20230219+4+gb056722) unstable; urgency=medium

  * WIP: debian: Release 0+0.0.20230219-0.0.20230219+4+gb056722
    (snapshot)

 -- Philippe Coval <rzr@users.sf.net>  Tue, 28 Feb 2023 21:26:17 +0100

pinball-table-hurd (0+0.0.20230219-0.0.20230219+3+g35a6c0f) unstable; urgency=medium

  * WIP: debian: Release 0+0.0.20230219-0.0.20230219+3+g35a6c0f
    (snapshot)

 -- Philippe Coval <rzr@users.sf.net>  Tue, 28 Feb 2023 21:20:15 +0100

pinball-table-hurd (0+0.0.20201119+18+g2383ec5-0.0.20201119+20+g9ebf46f) unstable; urgency=medium

  * WIP: debian: Release 0+0.0.20201119+18+g2383ec5-
    0.0.20201119+20+g9ebf46f (snapshot)

 -- Philippe Coval <rzr@users.sf.net>  Thu, 16 Feb 2023 23:50:24 +0100

pinball-table-hurd (0.0.0.20201119-0.0.20201119+1+ga18a155) unstable; urgency=medium

  * WIP: debian: Release 0.0.0.20201119-0.0.20201119+1+ga18a155
    (snapshot)

 -- Philippe Coval <rzr@users.sf.net>  Fri, 18 Dec 2020 03:27:16 +0100

pinball-table-hurd (0.0.0-0) unstable; urgency=medium

  * Initial release (Closes: #948659)

 -- Philippe Coval <rzr@users.sf.net>  Mon, 23 Dec 2019 23:51:35 +0100

=== debian/control ===
Source: pinball-table-hurd
Section: games
Priority: optional
Maintainer: Philippe Coval <rzr@users.sf.net>
Build-Depends: debhelper (>= 11),
 autoconf,
 automake,
 libtool,
 libltdl-dev (>= 2.2.6b),
 libsdl2-dev,
 pinball-dev
Standards-Version: 4.1.3
Homepage: https://github.com/rzr/pinball-table-hurd
Vcs-Git: https://github.com/rzr/pinball-table-hurd.git#debian/master
Vcs-Browser: https://github.com/rzr/pinball-table-hurd/tree/debian/master
Rules-Requires-Root: no

Package: pinball-table-hurd
Enhances: pinball
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 pinball,
 pinball-table-hurd-data (= ${source:Version})
Description: HURD Pinball table for emilia pinball
 Another pinball table to have fun, behaviour plugin.
 The table is dedicated to GNU/Hurd project.
 It features shoot cave, multiballs, ramps and bumpers.

Package: pinball-table-hurd-data
Architecture: all
Depends: ${misc:Depends}
Description: HURD Pinball table data used by plugin
 Visual and sounds for Emilia's pinball's HURD table.
 The table is dedicated to GNU/Hurd project.
 It features shoot cave, multiballs, ramps and bumpers.

Package: pinball-table-hurd-snapshot
Architecture: all
Section: utils
Depends: ${misc:Depends}, pinball-table-hurd (= ${source:Version})
Suggests: rzr
Priority: extra
Description: unreleased snapshot version
 TODO: Remove on issue and upgrade pinball-table-hurd

## pinball-table-hurd 0.0.20201119

=== debian/changelog ===
pinball-table-hurd (0.0.20201119-2) unstable; urgency=medium

  * Team upload.
  * Source-only upload

 -- Xavier Guimard <yadd@debian.org>  Sat, 05 Dec 2020 22:56:50 +0100

pinball-table-hurd (0.0.20201119-1) unstable; urgency=medium

  * Initial release (Closes: #948659)

 -- Philippe Coval <rzr@users.sf.net>  Fri, 20 Nov 2020 06:33:25 +0100

=== debian/control ===
Source: pinball-table-hurd
Maintainer: Philippe Coval <rzr@users.sf.net>
Section: games
Priority: optional
Build-Depends: debhelper-compat (= 13),
               autoconf,
               automake,
               libtool,
               libltdl-dev,
               libsdl1.2-dev,
               pinball-dev
Standards-Version: 4.5.0
Vcs-Browser: https://github.com/rzr/pinball-table-hurd/tree/debian/master
Vcs-Git: https://github.com/rzr/pinball-table-hurd.git#debian/master
Homepage: https://github.com/rzr/pinball-table-hurd
Rules-Requires-Root: no

Package: pinball-table-hurd
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         pinball,
         pinball-table-hurd-data (= ${source:Version})
Enhances: pinball
Description: HURD Pinball table for emilia pinball
 Another pinball table to have fun, behaviour plugin.
 The table is dedicated to GNU/Hurd project.
 It features shoot cave, multiballs, ramps and bumpers.

Package: pinball-table-hurd-data
Architecture: all
Depends: ${misc:Depends}
Description: HURD Pinball table data used by plugin
 Visual and sounds for Emilia's pinball's HURD table.
 The table is dedicated to GNU/Hurd project.
 It features shoot cave, multiballs, ramps and bumpers.

## pinball-table-hurd 0.0.20230219

=== debian/changelog ===
pinball-table-hurd (0.0.20230219-1) unstable; urgency=medium

  [Sylvain Beucler]
  * Team upload.
  * d/control: depend on SDL2-rewritten 'pinball' package
    (Closes: #1038534)

  [ Philippe Coval ]
  * New upstream release
  * debian: Support gbp
  * d/gbp.conf: Based on upstream tag
  * d/control: Update standards
  * d/control: Set Multi-Arch: foreign
  * d/control: Set team maintenance
  * d/copyright: Fix update-debian-copyright lintian

 -- Sylvain Beucler <beuc@debian.org>  Fri, 30 Jun 2023 14:00:26 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,7 @@
 Source: pinball-table-hurd
-Maintainer: Philippe Coval <rzr@users.sf.net>
+Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Uploaders:
+ Philippe Coval <rzr@users.sf.net>
 Section: games
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -7,9 +9,9 @@
                automake,
                libtool,
                libltdl-dev,
-               libsdl1.2-dev,
-               pinball-dev
-Standards-Version: 4.5.0
+               libsdl2-dev,
+               pinball-dev (>= 0.3.20230219)
+Standards-Version: 4.6.2
 Vcs-Browser: https://github.com/rzr/pinball-table-hurd/tree/debian/master
 Vcs-Git: https://github.com/rzr/pinball-table-hurd.git#debian/master
 Homepage: https://github.com/rzr/pinball-table-hurd
@@ -19,7 +21,7 @@
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         pinball,
+         pinball (>= 0.3.20230219),
          pinball-table-hurd-data (= ${source:Version})
 Enhances: pinball
 Description: HURD Pinball table for emilia pinball
@@ -29,6 +31,7 @@
 
 Package: pinball-table-hurd-data
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: HURD Pinball table data used by plugin
  Visual and sounds for Emilia's pinball's HURD table.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_VERBOSE = 1
DEB_BUILD_MAINT_OPTIONS += hardening=+all

project?=pinball-table-hurd
sudo?=sudo
tarball?=${CURDIR}/../${project}_${version}.orig.tar.gz
export tarball

version?=$(DEB_VERSION_UPSTREAM)

default: rule/debuild
	-sync

%:
	dh $@


.PHONY: override_dh_auto_configure

override_dh_autoreconf: bootstrap
	dh_autoreconf ${<D}/${<F}

override_dh_auto_configure:
	dh_auto_configure -- \
--bindir=/usr/games \
--datadir=/usr/share/games \
--with-cflags="$(CFLAGS)" \
--with-cxxflags="$(CXXFLAGS)" \
#EOL

override_dh_missing:
	dh_missing --list-missing

${tarball}:
	 tar cvfz "$@" \
--transform "s|^./|${project}-${version}/|" \
--exclude 'debian' --exclude-vcs \
.
	@ls -l $@

rule/tarball: ${tarball}
	@ls $^

rule/setup: /etc/debian_version
	${sudo} apt-get update -y
	${sudo} apt-get install -y \
build-essential \
dpkg-dev \
devscripts \
debhelper \
\
autoconf \
automake \
libtool-bin \
docbook-utils \
pinball-dev \
libsdl1.2-dev \
# EOL

rule/version:
	@echo ${version}
	-cat /etc/os-release
	${CC} --version
	${MAKE} --version
	aclocal --version
	autoconf --version
	automake --version
	libtool --version

rule/debuild: debian/rules
	@which ${@F} || ${<D}/${<F} ${@D}/setup
	[ "" != "${tarball}" ] || ${<D}/${<F} ${@D}/tarball
	@ls "${tarball}" 2>/dev/null || ${<D}/${<F} ${@D}/tarball
	${<D}/${<F} ${@D}/version
	${@F} -S -us -uc \
|| echo "# error: Try './debian/rules rule/setup' first"
	${@F} -S -us -uc
	${@F} -us -uc

=== debian/watch ===
version=4
https://github.com/rzr/@PACKAGE@/tags \
/rzr/@PACKAGE@/archive/@ANY_VERSION@@ARCHIVE_EXT@
